<template>
  <!-- UpdatePassword Form -->
  <form id="update-password-form">

    <!-- Error messages -->
    <t-alert v-if="form.globalError" variant="error" class="mb-8" show>
      <p class="text-error">{{ form.globalError }}</p>
    </t-alert>

    <!-- Password -->
    <InputPassword
      v-model="passwordValue"
      name="password"
      :variant="passwordState ? 'primary' : 'error'"
      :state="passwordState"
      :placeholder="$h.capitalize($t('user.newPassword'))"
      :label="$h.capitalize($t('user.newPassword'))"
      :description="$t('user.passwordPolicyDescription')"
      :error="getFieldErrorMessage('password')"
      fluid
    />

    <!-- Confirm password -->
    <InputPassword
      v-model="confirmPasswordValue"
      name="confirmPassword"
      :variant="confirmPasswordState ? 'primary' : 'error'"
      :state="confirmPasswordState"
      :label="$h.capitalize($t('user.confirmPassword'))"
      :placeholder="$h.capitalize($t('user.confirmPassword'))"
      fluid
      class="mb-4"
    />

    <!-- Confirm button -->
    <Button
      variant="primary"
      :disabled="!isFormValid"
      @click.native="handleOk"
      inline
      class="mr-4"
    >
      {{ $t('global.save') | capitalize }}
    </Button>

    <!-- Cancel button -->
    <Button
      variant="error"
      :disabled="!isFormValid"
      @click.native="handleCancel"
      inline
    >
      {{ $t('global.cancel') | capitalize }}
    </Button>

  </form>

</template>

<script>
// vuex helpers
import { mapState, mapActions } from 'vuex'
// BaseForm
import BaseForm from '@/components/commons/form/BaseForm'

/**
 * UpdatePasswordForm component
 */
export default {
  name: 'UpdatePasswordForm',
  extends: BaseForm,
  // 'form' option (see src/components/commons/form/BaseForm)
  form: {
    fields: {
      /**
       * password
       */
      password: {
        // Default: generate 'passwordValue' & 'passwordChanged'
        default: function () {
          return ''
        },
        // Generate: 'passwordState'
        state: function () {
          return !this.isFieldInError('password') // No errors ?
            ? this.passwordValue.length > 0 // Filled ?
              ? this.isPasswordValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isPasswordValid'
        isValid: function () {
          return this.$root.auth.doesPasswordMatchPolicy(this.passwordValue)
        }
      },
      /**
       * confirmPassword
       */
      confirmPassword: {
        // Default: generate 'confirmPasswordValue' & 'confirmPasswordChangedChanged'
        default: function () {
          return ''
        },
        // Generate: 'confirmPasswordState'
        state: function () {
          return !this.isFieldInError('confirmPassword') // No errors ?
            ? this.confirmPasswordValue.length > 0 // Filled ?
              ? this.isConfirmPasswordValid // Valid ?
              : true
            : false // else -> errors
        },
        // Generate: 'isConfirmPasswordValid'
        isValid: function () {
          return this.$root.auth.doesPasswordMatchPolicy(this.confirmPasswordValue) &&
            this.passwordValue === this.confirmPasswordValue
        }
      }
    }
  },
  computed: {
    // Map state from Auth module
    ...mapState('Auth', [
      'passwordForSecurity'
    ])
  },
  methods: {
    // Map actions from 'Users' store module
    ...mapActions('Users', [
      'updateUserPassword'
    ]),
    /**
     * Handle click on 'confirm' submit button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleOk (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors before
      this.resetErrors()
      // Display PaswordGuardModal
      this.$store.commit('SET_SYSTEM_SHOW_PASSWORD_GUARD_MODAL', true)
      // Define 'one-time' callback on global event
      this.$root.once('PASSWORD_SECURITY_CONFIRMED', async () => {
        await this.savePassword() // Save password
        this.$store.commit('Auth/RESET_PASSWORD_FOR_SECURITY') // Reset passwordForSecurity
      })
    },
    /**
     * Handle click on 'cancel' button.
     * @param {Object} evt - The event payload
     * @returns {void}
     */
    handleCancel (evt) {
      // Prevent click
      evt.preventDefault()
      // Reset errors
      this.resetErrors()
      // Reset form
      this.resetForm()
    },
    /**
     * Handle click on password 'save' button.
     * @returns {void}
     */
    async savePassword () {
      // Wait for update user password function
      const updatePasswordResponse = await this.updateUserPassword({
        data: {
          current_password: this.passwordForSecurity,
          password: this.passwordValue,
          password_confirmation: this.confirmPasswordValue
        }
      })
      // If passed
      if (!(updatePasswordResponse instanceof Error)) {
        // Reset form
        this.resetForm()
      // Else parse server error
      } else {
        this.setFormErrors(updatePasswordResponse) // Set form errors from response
      }
    }
  }
}
</script>
